using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    public partial class Rep_Dept_Assessment
    {
        public Rep_Dept_Assessment()
        { }
        #region  BasicMethod

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return DbHelperSQL.GetMaxID("F_Id", "Rep_Dept_Assessment");
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_Id)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from Rep_Dept_Assessment");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(Model.Rep_Dept_Assessment model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into Rep_Dept_Assessment(");
            strSql.Append("F_DeptId,F_TypeCode,F_GradeCode,F_Grade,F_Note,F_DateTime,F_CreateTime)");
            strSql.Append(" values (");
            strSql.Append("@F_DeptId,@F_TypeCode,@F_GradeCode,@F_Grade,@F_Note,@F_DateTime,@F_CreateTime)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_DeptId", SqlDbType.Int,4),
                    new SqlParameter("@F_TypeCode", SqlDbType.VarChar,20),
                    new SqlParameter("@F_GradeCode", SqlDbType.VarChar,20),
                    new SqlParameter("@F_Grade", SqlDbType.Float,8),
                    new SqlParameter("@F_Note", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_DateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime)};
            parameters[0].Value = model.F_DeptId;
            parameters[1].Value = model.F_TypeCode;
            parameters[2].Value = model.F_GradeCode;
            parameters[3].Value = model.F_Grade;
            parameters[4].Value = model.F_Note;
            parameters[5].Value = model.F_DateTime;
            parameters[6].Value = model.F_CreateTime;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(Model.Rep_Dept_Assessment model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update Rep_Dept_Assessment set ");
            strSql.Append("F_DeptId=@F_DeptId,");
            strSql.Append("F_TypeCode=@F_TypeCode,");
            strSql.Append("F_GradeCode=@F_GradeCode,");
            strSql.Append("F_Grade=@F_Grade,");
            strSql.Append("F_Note=@F_Note,");
            strSql.Append("F_DateTime=@F_DateTime,");
            strSql.Append("F_CreateTime=@F_CreateTime");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_DeptId", SqlDbType.Int,4),
                    new SqlParameter("@F_TypeCode", SqlDbType.VarChar,20),
                    new SqlParameter("@F_GradeCode", SqlDbType.VarChar,20),
                    new SqlParameter("@F_Grade", SqlDbType.Float,8),
                    new SqlParameter("@F_Note", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_DateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_Id", SqlDbType.Int,4)};
            parameters[0].Value = model.F_DeptId;
            parameters[1].Value = model.F_TypeCode;
            parameters[2].Value = model.F_GradeCode;
            parameters[3].Value = model.F_Grade;
            parameters[4].Value = model.F_Note;
            parameters[5].Value = model.F_DateTime;
            parameters[6].Value = model.F_CreateTime;
            parameters[7].Value = model.F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from Rep_Dept_Assessment ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_Idlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from Rep_Dept_Assessment ");
            strSql.Append(" where F_Id in (" + F_Idlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.Rep_Dept_Assessment GetModel(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_Id,F_DeptId,F_TypeCode,F_GradeCode,F_Grade,F_Note,F_DateTime,F_CreateTime from Rep_Dept_Assessment ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            Model.Rep_Dept_Assessment model = new Model.Rep_Dept_Assessment();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.Rep_Dept_Assessment DataRowToModel(DataRow row)
        {
            Model.Rep_Dept_Assessment model = new Model.Rep_Dept_Assessment();
            if (row != null)
            {
                if (row["F_Id"] != null && row["F_Id"].ToString() != "")
                {
                    model.F_Id = int.Parse(row["F_Id"].ToString());
                }
                if (row["F_DeptId"] != null && row["F_DeptId"].ToString() != "")
                {
                    model.F_DeptId = int.Parse(row["F_DeptId"].ToString());
                }
                if (row["F_TypeCode"] != null)
                {
                    model.F_TypeCode = row["F_TypeCode"].ToString();
                }
                if (row["F_GradeCode"] != null)
                {
                    model.F_GradeCode = row["F_GradeCode"].ToString();
                }
                if (row["F_Grade"] != null && row["F_Grade"].ToString() != "")
                {
                    model.F_Grade = decimal.Parse(row["F_Grade"].ToString());
                }
                if (row["F_Note"] != null)
                {
                    model.F_Note = row["F_Note"].ToString();
                }
                if (row["F_DateTime"] != null && row["F_DateTime"].ToString() != "")
                {
                    model.F_DateTime = DateTime.Parse(row["F_DateTime"].ToString());
                }
                if (row["F_CreateTime"] != null && row["F_CreateTime"].ToString() != "")
                {
                    model.F_CreateTime = DateTime.Parse(row["F_CreateTime"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_Id,F_DeptId,F_TypeCode,F_GradeCode,F_Grade,F_Note,F_DateTime,F_CreateTime ");
            strSql.Append(" FROM Rep_Dept_Assessment ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_Id,F_DeptId,F_TypeCode,F_GradeCode,F_Grade,F_Note,F_DateTime,F_CreateTime ");
            strSql.Append(" FROM Rep_Dept_Assessment ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM Rep_Dept_Assessment ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_Id desc");
            }
            strSql.Append(")AS Row, T.*  from Rep_Dept_Assessment T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "Rep_Dept_Assessment";
			parameters[1].Value = "F_Id";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
